//
// Created by nicol on 2018-03-18.
//

#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <memory.h>
#include "debug.h"
#include "uuid.h"

#define UUID_SIZE 16

int srand_called = 0;

struct st_uuid {
    char data[UUID_SIZE];
};

//TODO: fixme - this is not secure, use crypto random bytes instead of rand
uuid_t* uuid_create() {
    if (srand_called == 0) {
        srand(time(NULL));
        srand_called = 1;
    }
    uuid_t* result = malloc(sizeof(struct st_uuid));
    for(int i=0;i<UUID_SIZE;i++)
        result->data[i] = (uint8_t)(rand() & 0xff);
    return result;
}

inline void uuid_destroy(uuid_t* uuid) {
    free(uuid);
}

uuid_t* uuid_from(const uint8_t *src, size_t size) {
    if (size < UUID_SIZE) {
        return 0;
    }
    uuid_t* uuid = malloc(sizeof(struct st_uuid));
    memcpy(uuid->data, src, UUID_SIZE);
    return uuid;
}

uuid_t* uuid_copy(uuid_t* other) {
    return uuid_from((uint8_t *) other->data, UUID_SIZE);
}

int uuid_compare(uuid_t* left, uuid_t* right) {
    return memcmp(left->data, right->data, UUID_SIZE);
}

const char* uuid_format(uuid_t* uuid, char *buffer, size_t buf_size) {
#ifdef _WIN32
    snprintf(buffer, buf_size, "%08lx-%04hx-%04hx-%04hx-%08lx%04hx",
             *(long*)&uuid->data[0],
             *(short*)&uuid->data[4],
             *(short*)&uuid->data[6],
             *(short*)&uuid->data[8],
             *(long*)&uuid->data[10],
             *(short*)&uuid->data[14]);
#endif
#ifdef __linux__
    snprintf(buffer, buf_size, "%02hhx%02hhx%02hhx%02hhx-%02hhx%02hhx-%02hhx%02hhx-%02hhx%02hhx-%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx",
             uuid->data[0],
             uuid->data[1],
             uuid->data[2],
             uuid->data[3],
             uuid->data[4],
             uuid->data[5],
             uuid->data[6],
             uuid->data[7],
             uuid->data[8],
             uuid->data[9],
             uuid->data[10],
             uuid->data[11],
             uuid->data[12],
             uuid->data[13],
             uuid->data[14],
             uuid->data[15]);
#endif
    return buffer;
}
